import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, ViewChild, ContentChild, NgModule } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i3 from '@angular/forms';
import { FormControl, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { TrViewdefDirective, TrCommonModule } from '@truongcomp/truong-ui/common';
import * as i2 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';

class TrInputComponent {
    constructor() {
        this.formControl = new FormControl('le van truong');
        this.isFocused = true;
    }
    ngAfterContentInit() {
        console.log(this.tdView);
    }
    ngOnInit() {
        console.log(this.tdView);
    }
    onBlur() {
        this.isFocused = false;
    }
    onClick() {
        this.isFocused = true;
        setTimeout(() => {
            var _a;
            (_a = this.input) === null || _a === void 0 ? void 0 : _a.nativeElement.focus();
        });
    }
}
TrInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: TrInputComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TrInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.3", type: TrInputComponent, selector: "tr-input", queries: [{ propertyName: "tdView", first: true, predicate: TrViewdefDirective, descendants: true }], viewQueries: [{ propertyName: "input", first: true, predicate: ["input"], descendants: true }], ngImport: i0, template: "<div (click)=\"onClick()\">\n    <ng-container *ngIf=\"tdView && !isFocused else default\">\n        <ng-container [ngTemplateOutlet]=\"tdView.template\" [ngTemplateOutletContext]=\"{value: formControl.value}\">\n        </ng-container>\n    </ng-container>\n    <ng-template #default>\n        <input #input matInput type=\"text\" [formControl]=\"formControl\" (blur)=\"onBlur()\">\n    </ng-template>\n</div>", styles: [""], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: TrInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tr-input', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div (click)=\"onClick()\">\n    <ng-container *ngIf=\"tdView && !isFocused else default\">\n        <ng-container [ngTemplateOutlet]=\"tdView.template\" [ngTemplateOutletContext]=\"{value: formControl.value}\">\n        </ng-container>\n    </ng-container>\n    <ng-template #default>\n        <input #input matInput type=\"text\" [formControl]=\"formControl\" (blur)=\"onBlur()\">\n    </ng-template>\n</div>" }]
        }], ctorParameters: function () { return []; }, propDecorators: { input: [{
                type: ViewChild,
                args: ['input']
            }], tdView: [{
                type: ContentChild,
                args: [TrViewdefDirective]
            }] } });

class TdInputModule {
}
TdInputModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: TdInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
TdInputModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.3", ngImport: i0, type: TdInputModule, declarations: [TrInputComponent], imports: [CommonModule,
        TrCommonModule,
        MatInputModule,
        FormsModule,
        ReactiveFormsModule], exports: [TrInputComponent] });
TdInputModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: TdInputModule, imports: [CommonModule,
        TrCommonModule,
        MatInputModule,
        FormsModule,
        ReactiveFormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: TdInputModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [TrInputComponent],
                    imports: [
                        CommonModule,
                        TrCommonModule,
                        MatInputModule,
                        FormsModule,
                        ReactiveFormsModule,
                    ],
                    exports: [TrInputComponent],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { TdInputModule, TrInputComponent };
//# sourceMappingURL=truongcomp-truong-ui-input.mjs.map
