import { AfterContentInit, ElementRef, OnInit } from '@angular/core';
import { FormControl } from '@angular/forms';
import { TrViewdefDirective } from '@truongcomp/truong-ui/common';
import * as i0 from "@angular/core";
export declare class TrInputComponent implements OnInit, AfterContentInit {
    input: ElementRef | undefined;
    tdView: TrViewdefDirective | undefined;
    formControl: FormControl<string | null>;
    isFocused: boolean;
    constructor();
    ngAfterContentInit(): void;
    ngOnInit(): void;
    onBlur(): void;
    onClick(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TrInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TrInputComponent, "tr-input", never, {}, {}, ["tdView"], never, false>;
}
